mw.loader.implement("ext.eventLogging",function(){(function(mw,$,console){'use strict';function ValidationError(message){this.message=message;}ValidationError.prototype=new Error();var self=mw.eventLog={schemas:{},warn:console&&$.isFunction(console.warn)?$.proxy(console.warn,console):mw.log,declareSchema:function(schemaName,meta){if(self.schemas.hasOwnProperty(schemaName)){self.warn('Clobbering existing "'+schemaName+'" schema');}self.schemas[schemaName]=$.extend(true,{revision:-1,schema:{properties:{}},defaults:{}},self.schemas[schemaName],meta);return self.schemas[schemaName];},isInstanceOf:function(value,type){if(value===undefined||value===null){return false;}switch(type){case'string':return typeof value==='string';case'timestamp':return value instanceof Date||(typeof value==='number'&&value>=0&&value%1===0);case'boolean':return typeof value==='boolean';case'integer':return typeof value==='number'&&value%1===0;case'number':return typeof value==='number'&&isFinite(value);default:
return false;}},isValid:function(event,schemaName){try{self.assertValid(event,schemaName);return true;}catch(e){if(!(e instanceof ValidationError)){throw e;}self.warn('Validation error against schema '+schemaName+': '+e.message);return false;}},assertValid:function(event,schemaName){var schema=self.schemas[schemaName]||null,props=schema.schema.properties,prop;if($.isEmpty(props)){throw new ValidationError('Unknown schema: '+schemaName);}for(prop in event){if(props[prop]===undefined){throw new ValidationError('Unrecognized property: '+prop);}}$.each(props,function(prop,desc){var val=event[prop];if(val===undefined){if(desc.required){throw new ValidationError('Missing property: '+prop);}return true;}if(!(self.isInstanceOf(val,desc.type))){throw new ValidationError('Wrong type for property: '+prop+' '+val);}if(desc['enum']&&$.inArray(val,desc['enum'])===-1){throw new ValidationError('Value "'+val+'" for property: '+prop+' not in enum '+$.toJSON(desc['enum']));}});return true;},setDefaults:
function(schemaName,schemaDefaults){var schema=self.schemas[schemaName];if(schema===undefined){self.warn('Setting defaults on unknown schema "'+schemaName+'"');schema=self.declareSchema(schemaName);}return $.extend(true,schema.defaults,schemaDefaults);},prepare:function(schemaName,event){var prop,schema=self.schemas[schemaName];if(schema===undefined){self.warn('Got event with unknown schema "'+schemaName+'"');schema=self.declareSchema(schemaName);}event=$.extend(true,{},schema.defaults,event);for(prop in event){if(typeof event[prop]==='function'){event[prop]=event[prop].call(event);}}return{event:event,clientValidated:self.isValid(event,schemaName),revision:schema.revision,schema:schemaName,webHost:window.location.hostname,wiki:mw.config.get('wgDBname')};},dispatch:function(data){var beacon=document.createElement('img'),baseUri=mw.config.get('wgEventLoggingBaseUri'),dfd=$.Deferred();if(!baseUri){dfd.rejectWith(data,[data]);return dfd.promise();}$(beacon).on('error',function(){dfd.
resolveWith(data,[data]);});beacon.src=baseUri+'?'+encodeURIComponent($.toJSON(data))+';';return dfd.promise();},logEvent:function(schemaName,eventInstance){return self.dispatch(self.prepare(schemaName,eventInstance));}};if(!mw.config.get('wgEventLoggingBaseUri')){self.warn('"$wgEventLoggingBaseUri" is not set.');}}(mediaWiki,jQuery,window.console));},{},{});mw.loader.implement("ext.uls.preferences",function(){(function($,mw){'use strict';var ULSPreferences,cachedOptionsToken=null;function saveOptionsWithToken(params,ok,err){if(cachedOptionsToken===null){return getOptionsToken(function(token){params.token=token;new mw.Api().post(params,ok,err);},err);}else{params.token=cachedOptionsToken;return new mw.Api().post(params,{ok:ok,err:function(code,result){if(code==='badtoken'){cachedOptionsToken=null;saveOptionsWithToken(params,ok,err);}else{err(code,result);}}});}}function getOptionsToken(tokenCallback,err){return new mw.Api().get({action:'tokens',type:'options'},{ok:function(data){var
token;if(data.tokens&&data.tokens.optionstoken){token=data.tokens.optionstoken;cachedOptionsToken=token;tokenCallback(token);}else{err('token-missing',data);}},err:err,jsonp:false});}function preferenceStore(){return{set:function(key,value){if(typeof value==='object'){value=JSON.stringify(value);}try{localStorage.setItem(key,value);}catch(e){$.cookie(key,value,{path:'/'});}},get:function(key){var data;try{data=localStorage.getItem(key);if(!data){try{data=JSON.parse(localStorage.getItem('jStorage'))['uls-preferences'];localStorage.removeItem('jStorage');}catch(e){}}}catch(e){data=$.cookie(key);}try{data=JSON.parse(data);}catch(e){data=data;}return data;}};}ULSPreferences=function(){this.preferenceName='uls-preferences';this.username=mw.user.getName();this.isAnon=mw.user.isAnon();this.preferences=null;this.init();};ULSPreferences.prototype={init:function(){if(this.isAnon){this.preferences=preferenceStore().get(this.preferenceName);}else{var options=mw.user.options.get(this.preferenceName
);try{this.preferences=JSON.parse(options);}catch(e){this.preferences={};}}this.preferences=this.preferences||{};},set:function(key,value){this.preferences[key]=value;},get:function(key){return this.preferences[key];},save:function(callback){var ulsPreferences=this;callback=callback||$.noop;if(this.isAnon){preferenceStore().set(this.preferenceName,this.preferences);callback.call(this,true);}else{saveOptionsWithToken({action:'options',optionname:ulsPreferences.preferenceName,optionvalue:JSON.stringify(ulsPreferences.preferences)},function(){callback.call(this,true);},function(){callback.call(this,false);});}}};mw.uls=mw.uls||{};mw.uls.preferences=function(){var data=$('body').data('preferences');if(!data){$('body').data('preferences',(data=new ULSPreferences()));}return data;};}(jQuery,mediaWiki));},{},{});mw.loader.implement("ext.uls.webfonts",function(){(function($,mw){'use strict';var ulsPreferences,tofuSalt='\u0D00',tofuLanguages={};mw.webfonts=mw.webfonts||{};ulsPreferences=mw.uls.
preferences();mw.webfonts.preferences={registry:{fonts:{},webfontsEnabled:mw.config.get('wgULSWebfontsEnabled')},isEnabled:function(){return this.registry.webfontsEnabled;},enable:function(){this.registry.webfontsEnabled=true;},disable:function(){this.registry.webfontsEnabled=false;},setFont:function(language,font){this.registry.fonts[language]=font;},getFont:function(language){return this.registry.fonts[language];},save:function(callback){ulsPreferences=mw.uls.preferences();ulsPreferences.set('webfonts',this.registry);ulsPreferences.save(callback);},load:function(){mw.webfonts.preferences.registry=$.extend(this.registry,ulsPreferences.get('webfonts'));}};function detectTofu(text){var index,$fixture,width={},height={},length=Math.min(4,text.length),detected=false;if($.client.test({msie:false})){text=tofuSalt+text;}$fixture=$('<span>').css({fontSize:'72px',fontFamily:'sans-serif'}).appendTo('body');for(index=0;index<length;index++){$fixture.text(text[index]);width[index]=$fixture.width(
)||width[index-1];height[index]=$fixture.height();if(index>0&&(width[index]!==width[index-1]||height[index]!==height[index-1])){detected=false;break;}}$fixture.remove();if(index===length){detected=true;}return detected;}mw.webfonts.setup=function(){var mediawikiFontRepository=$.webfonts.repository;mediawikiFontRepository.base=mw.config.get('wgULSFontRepositoryBasePath');$.extend($.fn.webfonts.defaults,{repository:mediawikiFontRepository,fontStack:$('body').css('font-family').split(/, /g),exclude:mw.config.get('wgULSNoWebfontsSelectors').join(', ')});$.fn.webfonts.defaults=$.extend($.fn.webfonts.defaults,{fontSelector:function(repository,language,classes){var font,autonym,defaultFont;if(!language){return null;}defaultFont=repository.defaultFont(language);if(classes&&$.inArray('autonym',classes)>=0){autonym=true;}font=mw.webfonts.preferences.getFont(language);if(!font||autonym){if((!defaultFont||defaultFont==='system')&&!autonym){return font;}if(tofuLanguages[language]===undefined){
tofuLanguages[language]=detectTofu($.uls.data.getAutonym(language));if(tofuLanguages[language]){mw.log('tofu detected for '+language);mw.hook('mw.uls.webfonts.tofudetected').fire(language);}}if(tofuLanguages[language]){font=autonym?'Autonym':defaultFont;}else{font='system';}}if(font==='system'){font=null;}return font;},exclude:(function(){var excludes=$.fn.webfonts.defaults.exclude;if(mw.user.options.get('editfont')!=='default'){excludes=(excludes)?excludes+',textarea':'textarea';}return excludes;}())});setTimeout(function(){$('body').webfonts();$('body').data('webfonts').load('Autonym');},0);};$(document).ready(function(){mw.uls.init(function(){mw.webfonts.preferences.load();if(mw.webfonts.preferences.isEnabled()){mw.loader.using('ext.uls.webfonts.fonts',mw.webfonts.setup);}});});}(jQuery,mediaWiki));},{},{});mw.loader.implement("jquery.byteLength",function(){jQuery.byteLength=function(str){return str.replace(/[\u0080-\u07FF\uD800-\uDFFF]/g,'**').replace(
/[\u0800-\uD7FF\uE000-\uFFFF]/g,'***').length;};},{},{});mw.loader.implement("jquery.client",function(){(function($){var profileCache={};$.client={profile:function(nav){if(nav===undefined){nav=window.navigator;}if(profileCache[nav.userAgent+'|'+nav.platform]!==undefined){return profileCache[nav.userAgent+'|'+nav.platform];}var versionNumber,key=nav.userAgent+'|'+nav.platform,uk='unknown',x='x',wildUserAgents=['Opera','Navigator','Minefield','KHTML','Chrome','PLAYSTATION 3','Iceweasel'],userAgentTranslations=[[/(Firefox|MSIE|KHTML,?\slike\sGecko|Konqueror)/,''],['Chrome Safari','Chrome'],['KHTML','Konqueror'],['Minefield','Firefox'],['Navigator','Netscape'],['PLAYSTATION 3','PS3']],versionPrefixes=['camino','chrome','firefox','iceweasel','netscape','netscape6','opera','version','konqueror','lynx','msie','safari','ps3','android'],versionSuffix='(\\/|\\;?\\s|)([a-z0-9\\.\\+]*?)(\\;|dev|rel|\\)|\\s|$)',names=['camino','chrome','firefox','iceweasel','netscape','konqueror','lynx','msie',
'opera','safari','ipod','iphone','blackberry','ps3','rekonq','android'],nameTranslations=[],layouts=['gecko','konqueror','msie','trident','opera','webkit'],layoutTranslations=[['konqueror','khtml'],['msie','trident'],['opera','presto']],layoutVersions=['applewebkit','gecko','trident'],platforms=['win','wow64','mac','linux','sunos','solaris','iphone'],platformTranslations=[['sunos','solaris'],['wow64','win']],translate=function(source,translations){var i;for(i=0;i<translations.length;i++){source=source.replace(translations[i][0],translations[i][1]);}return source;},ua=nav.userAgent,match,name=uk,layout=uk,layoutversion=uk,platform=uk,version=x;if(match=new RegExp('('+wildUserAgents.join('|')+')').exec(ua)){ua=translate(ua,userAgentTranslations);}ua=ua.toLowerCase();if(match=new RegExp('('+names.join('|')+')').exec(ua)){name=translate(match[1],nameTranslations);}if(match=new RegExp('('+layouts.join('|')+')').exec(ua)){layout=translate(match[1],layoutTranslations);}if(match=new RegExp('('
+layoutVersions.join('|')+')\\\/(\\d+)').exec(ua)){layoutversion=parseInt(match[2],10);}if(match=new RegExp('('+platforms.join('|')+')').exec(nav.platform.toLowerCase())){platform=translate(match[1],platformTranslations);}if(match=new RegExp('('+versionPrefixes.join('|')+')'+versionSuffix).exec(ua)){version=match[3];}if(name==='safari'&&version>400){version='2.0';}if(name==='opera'&&version>=9.8){match=ua.match(/\bversion\/([0-9\.]*)/);if(match&&match[1]){version=match[1];}else{version='10';}}if(name==='chrome'&&(match=ua.match(/\bopr\/([0-9\.]*)/))){if(match[1]){name='opera';version=match[1];}}if(layout==='trident'&&layoutversion>=7&&(match=ua.match(/\brv[ :\/]([0-9\.]*)/))){if(match[1]){name='msie';version=match[1];}}if(match=ua.match(/\bsilk\/([0-9.\-_]*)/)){if(match[1]){name='silk';version=match[1];}}versionNumber=parseFloat(version,10)||0.0;return profileCache[key]={name:name,layout:layout,layoutVersion:layoutversion,platform:platform,version:version,versionBase:(version!==x?Math.
floor(versionNumber).toString():x),versionNumber:versionNumber};},test:function(map,profile,exactMatchOnly){var conditions,dir,i,op,val,j,pieceVersion,pieceVal,compare;profile=$.isPlainObject(profile)?profile:$.client.profile();if(map.ltr&&map.rtl){dir=$('body').is('.rtl')?'rtl':'ltr';map=map[dir];}if(typeof map!=='object'||map[profile.name]===undefined){return!exactMatchOnly;}conditions=map[profile.name];if(conditions===false){return false;}if(conditions===null){return true;}for(i=0;i<conditions.length;i++){op=conditions[i][0];val=conditions[i][1];if(typeof val==='string'){pieceVersion=profile.version.toString().split('.');pieceVal=val.split('.');while(pieceVersion.length<pieceVal.length){pieceVersion.push('0');}while(pieceVal.length<pieceVersion.length){pieceVal.push('0');}compare=0;for(j=0;j<pieceVersion.length;j++){if(Number(pieceVersion[j])<Number(pieceVal[j])){compare=-1;break;}else if(Number(pieceVersion[j])>Number(pieceVal[j])){compare=1;break;}}if(!(eval(''+compare+op+'0'))){
return false;}}else if(typeof val==='number'){if(!(eval('profile.versionNumber'+op+val))){return false;}}}return true;}};}(jQuery));},{},{});mw.loader.implement("jquery.json",function(){(function($){'use strict';var escape=/["\\\x00-\x1f\x7f-\x9f]/g,meta={'\b':'\\b','\t':'\\t','\n':'\\n','\f':'\\f','\r':'\\r','"':'\\"','\\':'\\\\'},hasOwn=Object.prototype.hasOwnProperty;$.toJSON=typeof JSON==='object'&&JSON.stringify?JSON.stringify:function(o){if(o===null){return'null';}var pairs,k,name,val,type=$.type(o);if(type==='undefined'){return undefined;}if(type==='number'||type==='boolean'){return String(o);}if(type==='string'){return $.quoteString(o);}if(typeof o.toJSON==='function'){return $.toJSON(o.toJSON());}if(type==='date'){var month=o.getUTCMonth()+1,day=o.getUTCDate(),year=o.getUTCFullYear(),hours=o.getUTCHours(),minutes=o.getUTCMinutes(),seconds=o.getUTCSeconds(),milli=o.getUTCMilliseconds();if(month<10){month='0'+month;}if(day<10){day='0'+day;}if(hours<10){hours='0'+hours;}if(
minutes<10){minutes='0'+minutes;}if(seconds<10){seconds='0'+seconds;}if(milli<100){milli='0'+milli;}if(milli<10){milli='0'+milli;}return'"'+year+'-'+month+'-'+day+'T'+hours+':'+minutes+':'+seconds+'.'+milli+'Z"';}pairs=[];if($.isArray(o)){for(k=0;k<o.length;k++){pairs.push($.toJSON(o[k])||'null');}return'['+pairs.join(',')+']';}if(typeof o==='object'){for(k in o){if(hasOwn.call(o,k)){type=typeof k;if(type==='number'){name='"'+k+'"';}else if(type==='string'){name=$.quoteString(k);}else{continue;}type=typeof o[k];if(type!=='function'&&type!=='undefined'){val=$.toJSON(o[k]);pairs.push(name+':'+val);}}}return'{'+pairs.join(',')+'}';}};$.evalJSON=typeof JSON==='object'&&JSON.parse?JSON.parse:function(str){return eval('('+str+')');};$.secureEvalJSON=typeof JSON==='object'&&JSON.parse?JSON.parse:function(str){var filtered=str.replace(/\\["\\\/bfnrtu]/g,'@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,']').replace(/(?:^|:|,)(?:\s*\[)+/g,'');if(/^[\],:{}\s]*$/.
test(filtered)){return eval('('+str+')');}throw new SyntaxError('Error parsing JSON, source is not valid.');};$.quoteString=function(str){if(str.match(escape)){return'"'+str.replace(escape,function(a){var c=meta[a];if(typeof c==='string'){return c;}c=a.charCodeAt();return'\\u00'+Math.floor(c/16).toString(16)+(c%16).toString(16);})+'"';}return'"'+str+'"';};}(jQuery));},{},{});mw.loader.implement("jquery.throttle-debounce",function(){(function(window,undefined){'$:nomunge';var $=window.jQuery||window.Cowboy||(window.Cowboy={}),jq_throttle;$.throttle=jq_throttle=function(delay,no_trailing,callback,debounce_mode){var timeout_id,last_exec=0;if(typeof no_trailing!=='boolean'){debounce_mode=callback;callback=no_trailing;no_trailing=undefined;}function wrapper(){var that=this,elapsed=+new Date()-last_exec,args=arguments;function exec(){last_exec=+new Date();callback.apply(that,args);};function clear(){timeout_id=undefined;};if(debounce_mode&&!timeout_id){exec();}timeout_id&&clearTimeout(
timeout_id);if(debounce_mode===undefined&&elapsed>delay){exec();}else if(no_trailing!==true){timeout_id=setTimeout(debounce_mode?clear:exec,debounce_mode===undefined?delay-elapsed:delay);}};if($.guid){wrapper.guid=callback.guid=callback.guid||$.guid++;}return wrapper;};$.debounce=function(delay,at_begin,callback){return callback===undefined?jq_throttle(delay,at_begin,false):jq_throttle(delay,callback,at_begin!==false);};})(this);},{},{});mw.loader.implement("jquery.tipsy",function(){(function($){function maybeCall(thing,ctx){return(typeof thing=='function')?(thing.call(ctx)):thing;}function fixTitle($ele){if($ele.attr('title')||typeof($ele.attr('original-title'))!='string'){$ele.attr('original-title',$ele.attr('title')||'').removeAttr('title');}}function Tipsy(element,options){this.$element=$(element);this.options=options;this.enabled=true;fixTitle(this.$element);}Tipsy.prototype={show:function(){var title=this.getTitle();if(title&&this.enabled){var $tip=this.tip();$tip.find(
'.tipsy-inner')[this.options.html?'html':'text'](title);$tip[0].className='tipsy';if(this.options.className){$tip.addClass(maybeCall(this.options.className,this.$element[0]));}$tip.remove().css({top:0,left:0,visibility:'hidden',display:'block'}).appendTo(document.body);var pos=$.extend({},this.$element.offset(),{width:this.$element[0].offsetWidth,height:this.$element[0].offsetHeight});var gravity=(typeof this.options.gravity=='function')?this.options.gravity.call(this.$element[0]):this.options.gravity;$tip.addClass('tipsy-'+gravity);if(this.options.className){$tip.addClass(maybeCall(this.options.className,this.$element[0]));}var actualWidth=$tip[0].offsetWidth,actualHeight=$tip[0].offsetHeight;var tp;switch(gravity.charAt(0)){case'n':tp={top:pos.top+pos.height+this.options.offset,left:pos.left+pos.width/2-actualWidth/2};break;case's':tp={top:pos.top-actualHeight-this.options.offset,left:pos.left+pos.width/2-actualWidth/2};break;case'e':tp={top:pos.top+pos.height/2-actualHeight/2,left:
pos.left-actualWidth-this.options.offset};break;case'w':tp={top:pos.top+pos.height/2-actualHeight/2,left:pos.left+pos.width+this.options.offset};break;}if(gravity.length==2){if(gravity.charAt(1)=='w'){if(this.options.center){tp.left=pos.left+pos.width/2-15;}else{tp.left=pos.left;}}else{if(this.options.center){tp.left=pos.left+pos.width/2-actualWidth+15;}else{tp.left=pos.left+pos.width;}}}$tip.css(tp);if(this.options.fade){$tip.stop().css({opacity:0,display:'block',visibility:'visible'}).animate({opacity:this.options.opacity},100);}else{$tip.css({visibility:'visible',opacity:this.options.opacity});}}},hide:function(){if(this.options.fade){this.tip().stop().fadeOut(100,function(){$(this).remove();});}else{this.tip().remove();}},getTitle:function(){var title,$e=this.$element,o=this.options;fixTitle($e);if(typeof o.title=='string'){title=$e.attr(o.title=='title'?'original-title':o.title);}else if(typeof o.title=='function'){title=o.title.call($e[0]);}title=(''+title).replace(/(^\s*|\s*$)/,
"");return title||o.fallback;},tip:function(){if(!this.$tip){this.$tip=$('<div class="tipsy"></div>').html('<div class="tipsy-arrow"></div><div class="tipsy-inner"/></div>');}return this.$tip;},validate:function(){if(!this.$element[0].parentNode){this.hide();this.$element=null;this.options=null;}},enable:function(){this.enabled=true;},disable:function(){this.enabled=false;},toggleEnabled:function(){this.enabled=!this.enabled;}};$.fn.tipsy=function(options){if(options===true){return this.data('tipsy');}else if(typeof options=='string'){return this.data('tipsy')[options]();}options=$.extend({},$.fn.tipsy.defaults,options);function get(ele){var tipsy=$.data(ele,'tipsy');if(!tipsy){tipsy=new Tipsy(ele,$.fn.tipsy.elementOptions(ele,options));$.data(ele,'tipsy',tipsy);}return tipsy;}function enter(){var tipsy=get(this);tipsy.hoverState='in';if(options.delayIn==0){tipsy.show();}else{setTimeout(function(){if(tipsy.hoverState=='in')tipsy.show();},options.delayIn);}};function leave(){var tipsy=
get(this);tipsy.hoverState='out';if(options.delayOut==0){tipsy.hide();}else{setTimeout(function(){if(tipsy.hoverState=='out')tipsy.hide();},options.delayOut);}};if(!options.live)this.each(function(){get(this);});if(options.trigger!='manual'){var binder=options.live?'live':'bind',eventIn=options.trigger=='hover'?'mouseenter':'focus',eventOut=options.trigger=='hover'?'mouseleave':'blur';this[binder](eventIn,enter)[binder](eventOut,leave);}return this;};$.fn.tipsy.defaults={className:null,delayIn:0,delayOut:0,fade:true,fallback:'',gravity:'n',center:true,html:false,live:false,offset:0,opacity:1.0,title:'title',trigger:'hover'};$.fn.tipsy.elementOptions=function(ele,options){return $.metadata?$.extend({},options,$(ele).metadata()):options;};$.fn.tipsy.autoNS=function(){return $(this).offset().top>($(document).scrollTop()+$(window).height()/2)?'s':'n';};$.fn.tipsy.autoWE=function(){return $(this).offset().left>($(document).scrollLeft()+$(window).width()/2)?'e':'w';};})(jQuery);},{"css":[
".tipsy{padding:5px;position:absolute;z-index:100000;cursor:default}.tipsy-inner{padding:5px 8px 4px 8px; background-color:#ffffff;border:solid 1px #a7d7f9;color:black;max-width:15em;border-radius:4px;-moz-border-radius:4px;-webkit-border-radius:4px; }.tipsy-arrow{position:absolute;background:url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAsAAAALAgMAAADUwp+1AAAACVBMVEX5+fmn1/n///9s6BFKAAAAAXRSTlMAQObYZgAAACpJREFUCB1jZBD4wMiQMoeRcUU4I9uSaYxSE54xZjn8AtMgPkgcJA9UBwAeDw1Qrb3pVAAAAABJRU5ErkJggg==) no-repeat top left;background:url(//bits.wikimedia.org/static-1.23wmf22/resources/src/jquery.tipsy/images/tipsy.png?2014-04-10T16:08:20Z) no-repeat top left!ie;width:11px;height:6px} .tipsy-n .tipsy-arrow{top:0px;left:50%;margin-left:-5px} .tipsy-nw .tipsy-arrow{top:1px;left:10px} .tipsy-ne .tipsy-arrow{top:1px;right:10px} .tipsy-s .tipsy-arrow{bottom:0px;left:50%;margin-left:-5px;background-position:bottom left} .tipsy-sw .tipsy-arrow{bottom:0px;left:10px;background-position:bottom left} .tipsy-se .tipsy-arrow{bottom:0px;right:10px;background-position:bottom left} .tipsy-e .tipsy-arrow{top:50%;margin-top:-5px;right:1px;width:5px;height:11px;background-position:top right} .tipsy-w .tipsy-arrow{top:50%;margin-top:-5px;left:0px;width:6px;height:11px}\n/* cache key: enwiki:resourceloader:filter:minify-css:7:0ce172c74a39c69927e13923b253f3a1 */"
]},{});mw.loader.implement("mediawiki.Title",function(){(function(mw,$){function Title(title,namespace){var parsed=parse(title,namespace);if(!parsed){throw new Error('Unable to parse title');}this.namespace=parsed.namespace;this.title=parsed.title;this.ext=parsed.ext;this.fragment=parsed.fragment;return this;}var NS_MAIN=0,NS_TALK=1,NS_SPECIAL=-1,getNsIdByName=function(ns){var id;if(typeof ns!=='string'){return false;}ns=ns.toLowerCase();id=mw.config.get('wgNamespaceIds')[ns];if(id===undefined){return false;}return id;},rUnderscoreTrim=/^_+|_+$/g,rSplit=/^(.+?)_*:_*(.*)$/,rInvalid=new RegExp('[^'+mw.config.get('wgLegalTitleChars')+']'+'|%[0-9A-Fa-f]{2}'+'|&[A-Za-z0-9\u0080-\uFFFF]+;'+'|&#[0-9]+;'+'|&#x[0-9A-Fa-f]+;'),parse=function(title,defaultNamespace){var namespace,m,id,i,fragment,ext;namespace=defaultNamespace===undefined?NS_MAIN:defaultNamespace;title=title.replace(/[ _\s]+/g,'_').replace(rUnderscoreTrim,'');if(title!==''&&title.charAt(0)===':'){namespace=NS_MAIN;title=title.
substr(1).replace(rUnderscoreTrim,'');}if(title===''){return false;}m=title.match(rSplit);if(m){id=getNsIdByName(m[1]);if(id!==false){namespace=id;title=m[2];if(namespace===NS_TALK&&(m=title.match(rSplit))){if(getNsIdByName(m[1])!==false){return false;}}}}i=title.indexOf('#');if(i===-1){fragment=null;}else{fragment=title.substr(i+1).replace(/_/g,' ');title=title.substr(0,i).replace(rUnderscoreTrim,'');}if(title.match(rInvalid)){return false;}if(title.indexOf('.')!==-1&&(title==='.'||title==='..'||title.indexOf('./')===0||title.indexOf('../')===0||title.indexOf('/./')!==-1||title.indexOf('/../')!==-1||title.substr(title.length-2)==='/.'||title.substr(title.length-3)==='/..')){return false;}if(title.indexOf('~~~')!==-1){return false;}if(namespace!==NS_SPECIAL&&$.byteLength(title)>255){return false;}if(title===''&&namespace!==NS_MAIN){return false;}if(title.charAt(0)===':'){return false;}i=title.lastIndexOf('.');if(i===-1||title.length<=i+1){ext=null;}else{ext=title.substr(i+1);title=
title.substr(0,i);}return{namespace:namespace,title:title,ext:ext,fragment:fragment};},text=function(s){if(s!==null&&s!==undefined){return s.replace(/_/g,' ');}else{return'';}},createObject=Object.create||(function(){return function(o){function Title(){}if(o!==Object(o)){throw new Error('Cannot inherit from a non-object');}Title.prototype=o;return new Title();};}());Title.newFromText=function(title,namespace){var t,parsed=parse(title,namespace);if(!parsed){return null;}t=createObject(Title.prototype);t.namespace=parsed.namespace;t.title=parsed.title;t.ext=parsed.ext;t.fragment=parsed.fragment;return t;};Title.newFromImg=function(img){var matches,i,regex,src,decodedSrc,thumbPhpRegex=/thumb\.php/,regexes=[/\/[a-f0-9]\/[a-f0-9]{2}\/([^\s\/]+)\/[^\s\/]+-(?:\1|thumbnail)[^\s\/]*$/,/\/([^\s\/]+)\/[^\s\/]+-(?:\1|thumbnail)[^\s\/]*$/,/\/[a-f0-9]\/[a-f0-9]{2}\/([^\s\/]+)$/,/\/([^\s\/]+)$/],recount=regexes.length;src=img.jquery?img[0].src:img.src;matches=src.match(thumbPhpRegex);if(matches){
return mw.Title.newFromText('File:'+mw.util.getParamValue('f',src));}decodedSrc=decodeURIComponent(src);for(i=0;i<recount;i++){regex=regexes[i];matches=decodedSrc.match(regex);if(matches&&matches[1]){return mw.Title.newFromText('File:'+matches[1]);}}return null;};Title.exists=function(title){var match,type=$.type(title),obj=Title.exist.pages;if(type==='string'){match=obj[title];}else if(type==='object'&&title instanceof Title){match=obj[title.toString()];}else{throw new Error('mw.Title.exists: title must be a string or an instance of Title');}if(typeof match==='boolean'){return match;}return null;};Title.exist={pages:{},set:function(titles,state){titles=$.isArray(titles)?titles:[titles];state=state===undefined?true:!!state;var pages=this.pages,i,len=titles.length;for(i=0;i<len;i++){pages[titles[i]]=state;}return true;}};Title.prototype={constructor:Title,getNamespaceId:function(){return this.namespace;},getNamespacePrefix:function(){return this.namespace===NS_MAIN?'':(mw.config.get(
'wgFormattedNamespaces')[this.namespace].replace(/ /g,'_')+':');},getName:function(){if($.inArray(this.namespace,mw.config.get('wgCaseSensitiveNamespaces'))!==-1){return this.title;}else{return $.ucFirst(this.title);}},getNameText:function(){return text(this.getName());},getExtension:function(){return this.ext;},getDotExtension:function(){return this.ext===null?'':'.'+this.ext;},getMain:function(){return this.getName()+this.getDotExtension();},getMainText:function(){return text(this.getMain());},getPrefixedDb:function(){return this.getNamespacePrefix()+this.getMain();},getPrefixedText:function(){return text(this.getPrefixedDb());},getFragment:function(){return this.fragment;},getUrl:function(params){return mw.util.getUrl(this.toString(),params);},exists:function(){return Title.exists(this);}};Title.prototype.toString=Title.prototype.getPrefixedDb;Title.prototype.toText=Title.prototype.getPrefixedText;mw.Title=Title;}(mediaWiki,jQuery));},{},{});mw.loader.implement("mediawiki.Uri",
function(){(function(mw,$){function cat(pre,val,post,raw){if(val===undefined||val===null||val===''){return'';}return pre+(raw?val:mw.Uri.encode(val))+post;}var parser={strict:/^(?:([^:\/?#]+):)?(?:\/\/(?:(?:([^:@\/?#]*)(?::([^:@\/?#]*))?)?@)?([^:\/?#]*)(?::(\d*))?)?((?:[^?#\/]*\/)*[^?#]*)(?:\?([^#]*))?(?:#(.*))?/,loose:/^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?(?:(?:([^:@\/?#]*)(?::([^:@\/?#]*))?)?@)?([^:\/?#]*)(?::(\d*))?((?:\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?[^?#\/]*)(?:\?([^#]*))?(?:#(.*))?/},properties=['protocol','user','password','host','port','path','query','fragment'];mw.UriRelative=function(documentLocation){var defaultUri;function Uri(uri,options){options=typeof options==='object'?options:{strictMode:!!options};options=$.extend({strictMode:false,overrideKeys:false},options);if(uri!==undefined&&uri!==null&&uri!==''){if(typeof uri==='string'){this.parse(uri,options);}else if(typeof uri==='object'){for(var prop in uri){if(uri.hasOwnProperty(prop)){if($.
isArray(uri[prop])||$.isPlainObject(uri[prop])){this[prop]=$.extend(true,{},uri[prop]);}else{this[prop]=uri[prop];}}}if(!this.query){this.query={};}}}else{return defaultUri.clone();}if(!this.protocol){this.protocol=defaultUri.protocol;}if(!this.host){this.host=defaultUri.host;if(!this.port){this.port=defaultUri.port;}}if(this.path&&this.path.charAt(0)!=='/'){throw new Error('Bad constructor arguments');}if(!(this.protocol&&this.host&&this.path)){throw new Error('Bad constructor arguments');}}Uri.encode=function(s){return encodeURIComponent(s).replace(/!/g,'%21').replace(/'/g,'%27').replace(/\(/g,'%28').replace(/\)/g,'%29').replace(/\*/g,'%2A').replace(/%20/g,'+');};Uri.decode=function(s){return decodeURIComponent(s.replace(/\+/g,'%20'));};Uri.prototype={parse:function(str,options){var q,matches,uri=this;matches=parser[options.strictMode?'strict':'loose'].exec(str);$.each(properties,function(i,property){uri[property]=matches[i+1];});q={};if(uri.query){uri.query.replace(
/(?:^|&)([^&=]*)(?:(=)([^&]*))?/g,function($0,$1,$2,$3){var k,v;if($1){k=Uri.decode($1);v=($2===''||$2===undefined)?null:Uri.decode($3);if(options.overrideKeys||q[k]===undefined){q[k]=v;}else{if(typeof q[k]==='string'){q[k]=[q[k]];}if($.isArray(q[k])){q[k].push(v);}}}});}uri.query=q;},getUserInfo:function(){return cat('',this.user,cat(':',this.password,''));},getHostPort:function(){return this.host+cat(':',this.port,'');},getAuthority:function(){return cat('',this.getUserInfo(),'@')+this.getHostPort();},getQueryString:function(){var args=[];$.each(this.query,function(key,val){var k=Uri.encode(key),vals=$.isArray(val)?val:[val];$.each(vals,function(i,v){if(v===null){args.push(k);}else if(k==='title'){args.push(k+'='+mw.util.wikiUrlencode(v));}else{args.push(k+'='+Uri.encode(v));}});});return args.join('&');},getRelativePath:function(){return this.path+cat('?',this.getQueryString(),'',true)+cat('#',this.fragment,'');},toString:function(){return this.protocol+'://'+this.getAuthority()+
this.getRelativePath();},clone:function(){return new Uri(this);},extend:function(parameters){$.extend(this.query,parameters);return this;}};defaultUri=new Uri(documentLocation);return Uri;};if(document&&document.location&&document.location.href){mw.Uri=mw.UriRelative(document.location.href);}}(mediaWiki,jQuery));},{},{});mw.loader.implement("mediawiki.jqueryMsg",function(){(function(mw,$){var oldParser,slice=Array.prototype.slice,parserDefaults={magic:{'SITENAME':mw.config.get('wgSiteName')},allowedHtmlElements:['b','i'],allowedHtmlCommonAttributes:['id','class','style','lang','dir','title','role'],allowedHtmlAttributesByElement:{},messages:mw.messages,language:mw.language,format:'parse'};function appendWithoutParsing($parent,children){var i,len;if(!$.isArray(children)){children=[children];}for(i=0,len=children.length;i<len;i++){if(typeof children[i]!=='object'){children[i]=document.createTextNode(children[i]);}}return $parent.append(children);}function decodePrimaryHtmlEntities(
encoded){return encoded.replace(/&#039;/g,'\'').replace(/&quot;/g,'"').replace(/&lt;/g,'<').replace(/&gt;/g,'>').replace(/&amp;/g,'&');}function getFailableParserFn(options){var parser=new mw.jqueryMsg.parser(options);return function(args){var key=args[0],argsArray=$.isArray(args[1])?args[1]:slice.call(args,1);try{return parser.parse(key,argsArray);}catch(e){var fallback=parser.settings.messages.get(key);mw.log.warn('mediawiki.jqueryMsg: '+key+': '+e.message);return $('<span>').text(fallback);}};}mw.jqueryMsg={};mw.jqueryMsg.getMessageFunction=function(options){var failableParserFn=getFailableParserFn(options),format;if(options&&options.format!==undefined){format=options.format;}else{format=parserDefaults.format;}return function(){var failableResult=failableParserFn(arguments);if(format==='text'||format==='escaped'){return failableResult.text();}else{return failableResult.html();}};};mw.jqueryMsg.getPlugin=function(options){var failableParserFn=getFailableParserFn(options);return function
(){var $target=this.empty();$.each(failableParserFn(arguments).contents(),function(i,node){appendWithoutParsing($target,node);});return $target;};};mw.jqueryMsg.parser=function(options){this.settings=$.extend({},parserDefaults,options);this.settings.onlyCurlyBraceTransform=(this.settings.format==='text'||this.settings.format==='escaped');this.emitter=new mw.jqueryMsg.htmlEmitter(this.settings.language,this.settings.magic);};mw.jqueryMsg.parser.prototype={astCache:{},parse:function(key,replacements){return this.emitter.emit(this.getAst(key),replacements);},getAst:function(key){var cacheKey=[key,this.settings.onlyCurlyBraceTransform].join(':'),wikiText;if(this.astCache[cacheKey]===undefined){wikiText=this.settings.messages.get(key);if(typeof wikiText!=='string'){wikiText='\\['+key+'\\]';}this.astCache[cacheKey]=this.wikiTextToAst(wikiText);}return this.astCache[cacheKey];},wikiTextToAst:function(input){var pos,settings=this.settings,concat=Array.prototype.concat,regularLiteral,
regularLiteralWithoutBar,regularLiteralWithoutSpace,regularLiteralWithSquareBrackets,doubleQuote,singleQuote,backslash,anyCharacter,asciiAlphabetLiteral,escapedOrLiteralWithoutSpace,escapedOrLiteralWithoutBar,escapedOrRegularLiteral,whitespace,dollar,digits,htmlDoubleQuoteAttributeValue,htmlSingleQuoteAttributeValue,htmlAttributeEquals,openHtmlStartTag,optionalForwardSlash,openHtmlEndTag,closeHtmlTag,openExtlink,closeExtlink,wikilinkPage,wikilinkContents,openWikilink,closeWikilink,templateName,pipe,colon,templateContents,openTemplate,closeTemplate,nonWhitespaceExpression,paramExpression,expression,curlyBraceTransformExpression,result;pos=0;function choice(ps){return function(){var i,result;for(i=0;i<ps.length;i++){result=ps[i]();if(result!==null){return result;}}return null;};}function sequence(ps){var i,res,originalPos=pos,result=[];for(i=0;i<ps.length;i++){res=ps[i]();if(res===null){pos=originalPos;return null;}result.push(res);}return result;}function nOrMore(n,p){return function(){
var originalPos=pos,result=[],parsed=p();while(parsed!==null){result.push(parsed);parsed=p();}if(result.length<n){pos=originalPos;return null;}return result;};}function transform(p,fn){return function(){var result=p();return result===null?null:fn(result);};}function makeStringParser(s){var len=s.length;return function(){var result=null;if(input.substr(pos,len)===s){result=s;pos+=len;}return result;};}function makeRegexParser(regex){return function(){var matches=input.substr(pos).match(regex);if(matches===null){return null;}pos+=matches[0].length;return matches[0];};}regularLiteral=makeRegexParser(/^[^{}\[\]$<\\]/);regularLiteralWithoutBar=makeRegexParser(/^[^{}\[\]$\\|]/);regularLiteralWithoutSpace=makeRegexParser(/^[^{}\[\]$\s]/);regularLiteralWithSquareBrackets=makeRegexParser(/^[^{}$\\]/);backslash=makeStringParser('\\');doubleQuote=makeStringParser('"');singleQuote=makeStringParser('\'');anyCharacter=makeRegexParser(/^./);openHtmlStartTag=makeStringParser('<');optionalForwardSlash=
makeRegexParser(/^\/?/);openHtmlEndTag=makeStringParser('</');htmlAttributeEquals=makeRegexParser(/^\s*=\s*/);closeHtmlTag=makeRegexParser(/^\s*>/);function escapedLiteral(){var result=sequence([backslash,anyCharacter]);return result===null?null:result[1];}escapedOrLiteralWithoutSpace=choice([escapedLiteral,regularLiteralWithoutSpace]);escapedOrLiteralWithoutBar=choice([escapedLiteral,regularLiteralWithoutBar]);escapedOrRegularLiteral=choice([escapedLiteral,regularLiteral]);function literalWithoutSpace(){var result=nOrMore(1,escapedOrLiteralWithoutSpace)();return result===null?null:result.join('');}function literalWithoutBar(){var result=nOrMore(1,escapedOrLiteralWithoutBar)();return result===null?null:result.join('');}function unescapedLiteralWithoutBar(){var result=nOrMore(1,regularLiteralWithoutBar)();return result===null?null:result.join('');}function literal(){var result=nOrMore(1,escapedOrRegularLiteral)();return result===null?null:result.join('');}function
curlyBraceTransformExpressionLiteral(){var result=nOrMore(1,regularLiteralWithSquareBrackets)();return result===null?null:result.join('');}asciiAlphabetLiteral=makeRegexParser(/[A-Za-z]+/);htmlDoubleQuoteAttributeValue=makeRegexParser(/^[^"]*/);htmlSingleQuoteAttributeValue=makeRegexParser(/^[^']*/);whitespace=makeRegexParser(/^\s+/);dollar=makeStringParser('$');digits=makeRegexParser(/^\d+/);function replacement(){var result=sequence([dollar,digits]);if(result===null){return null;}return['REPLACE',parseInt(result[1],10)-1];}openExtlink=makeStringParser('[');closeExtlink=makeStringParser(']');function extlink(){var result,parsedResult;result=null;parsedResult=sequence([openExtlink,nonWhitespaceExpression,whitespace,nOrMore(1,expression),closeExtlink]);if(parsedResult!==null){result=['EXTLINK',parsedResult[1]];if(parsedResult[3].length===1){result.push(parsedResult[3][0]);}else{result.push(['CONCAT'].concat(parsedResult[3]));}}return result;}function extLinkParam(){var result=sequence([
openExtlink,dollar,digits,whitespace,expression,closeExtlink]);if(result===null){return null;}return['EXTLINKPARAM',parseInt(result[2],10)-1,result[4]];}openWikilink=makeStringParser('[[');closeWikilink=makeStringParser(']]');pipe=makeStringParser('|');function template(){var result=sequence([openTemplate,templateContents,closeTemplate]);return result===null?null:result[1];}wikilinkPage=choice([unescapedLiteralWithoutBar,template]);function pipedWikilink(){var result=sequence([wikilinkPage,pipe,expression]);return result===null?null:[result[0],result[2]];}wikilinkContents=choice([pipedWikilink,wikilinkPage]);function wikilink(){var result,parsedResult,parsedLinkContents;result=null;parsedResult=sequence([openWikilink,wikilinkContents,closeWikilink]);if(parsedResult!==null){parsedLinkContents=parsedResult[1];result=['WIKILINK'].concat(parsedLinkContents);}return result;}function doubleQuotedHtmlAttributeValue(){var parsedResult=sequence([doubleQuote,htmlDoubleQuoteAttributeValue,
doubleQuote]);return parsedResult===null?null:parsedResult[1];}function singleQuotedHtmlAttributeValue(){var parsedResult=sequence([singleQuote,htmlSingleQuoteAttributeValue,singleQuote]);return parsedResult===null?null:parsedResult[1];}function htmlAttribute(){var parsedResult=sequence([whitespace,asciiAlphabetLiteral,htmlAttributeEquals,choice([doubleQuotedHtmlAttributeValue,singleQuotedHtmlAttributeValue])]);return parsedResult===null?null:[parsedResult[1],parsedResult[3]];}function isAllowedHtml(startTagName,endTagName,attributes){var i,len,attributeName;startTagName=startTagName.toLowerCase();endTagName=endTagName.toLowerCase();if(startTagName!==endTagName||$.inArray(startTagName,settings.allowedHtmlElements)===-1){return false;}for(i=0,len=attributes.length;i<len;i+=2){attributeName=attributes[i];if($.inArray(attributeName,settings.allowedHtmlCommonAttributes)===-1&&$.inArray(attributeName,settings.allowedHtmlAttributesByElement[startTagName]||[])===-1){return false;}}return true
;}function htmlAttributes(){var parsedResult=nOrMore(0,htmlAttribute)();return concat.apply(['HTMLATTRIBUTES'],parsedResult);}function html(){var result=null,parsedOpenTagResult,parsedHtmlContents,parsedCloseTagResult,wrappedAttributes,attributes,startTagName,endTagName,startOpenTagPos,startCloseTagPos,endOpenTagPos,endCloseTagPos;startOpenTagPos=pos;parsedOpenTagResult=sequence([openHtmlStartTag,asciiAlphabetLiteral,htmlAttributes,optionalForwardSlash,closeHtmlTag]);if(parsedOpenTagResult===null){return null;}endOpenTagPos=pos;startTagName=parsedOpenTagResult[1];parsedHtmlContents=nOrMore(0,expression)();startCloseTagPos=pos;parsedCloseTagResult=sequence([openHtmlEndTag,asciiAlphabetLiteral,closeHtmlTag]);if(parsedCloseTagResult===null){return['CONCAT',input.substring(startOpenTagPos,endOpenTagPos)].concat(parsedHtmlContents);}endCloseTagPos=pos;endTagName=parsedCloseTagResult[1];wrappedAttributes=parsedOpenTagResult[2];attributes=wrappedAttributes.slice(1);if(isAllowedHtml(
startTagName,endTagName,attributes)){result=['HTMLELEMENT',startTagName,wrappedAttributes].concat(parsedHtmlContents);}else{result=['CONCAT',input.substring(startOpenTagPos,endOpenTagPos)].concat(parsedHtmlContents,input.substring(startCloseTagPos,endCloseTagPos));}return result;}templateName=transform(makeRegexParser(/^[ !"$&'()*,.\/0-9;=?@A-Z\^_`a-z~\x80-\xFF+\-]+/),function(result){return result.toString();});function templateParam(){var expr,result;result=sequence([pipe,nOrMore(0,paramExpression)]);if(result===null){return null;}expr=result[1];return expr.length>1?['CONCAT'].concat(expr):expr[0];}function templateWithReplacement(){var result=sequence([templateName,colon,replacement]);return result===null?null:[result[0],result[2]];}function templateWithOutReplacement(){var result=sequence([templateName,colon,paramExpression]);return result===null?null:[result[0],result[2]];}function templateWithOutFirstParameter(){var result=sequence([templateName,colon]);return result===null?null:
[result[0],''];}colon=makeStringParser(':');templateContents=choice([function(){var res=sequence([choice([templateWithReplacement,templateWithOutReplacement,templateWithOutFirstParameter]),nOrMore(0,templateParam)]);return res===null?null:res[0].concat(res[1]);},function(){var res=sequence([templateName,nOrMore(0,templateParam)]);if(res===null){return null;}return[res[0]].concat(res[1]);}]);openTemplate=makeStringParser('{{');closeTemplate=makeStringParser('}}');nonWhitespaceExpression=choice([template,wikilink,extLinkParam,extlink,replacement,literalWithoutSpace]);paramExpression=choice([template,wikilink,extLinkParam,extlink,replacement,literalWithoutBar]);expression=choice([template,wikilink,extLinkParam,extlink,replacement,html,literal]);curlyBraceTransformExpression=choice([template,replacement,curlyBraceTransformExpressionLiteral]);function start(rootExpression){var result=nOrMore(0,rootExpression)();if(result===null){return null;}return['CONCAT'].concat(result);}result=start(
this.settings.onlyCurlyBraceTransform?curlyBraceTransformExpression:expression);if(result===null||pos!==input.length){throw new Error('Parse error at position '+pos.toString()+' in input: '+input);}return result;}};mw.jqueryMsg.htmlEmitter=function(language,magic){this.language=language;var jmsg=this;$.each(magic,function(key,val){jmsg[key.toLowerCase()]=function(){return val;};});this.emit=function(node,replacements){var ret,subnodes,operation,jmsg=this;switch(typeof node){case'string':case'number':ret=node;break;case'object':subnodes=$.map(node.slice(1),function(n){return jmsg.emit(n,replacements);});operation=node[0].toLowerCase();if(typeof jmsg[operation]==='function'){ret=jmsg[operation](subnodes,replacements);}else{throw new Error('Unknown operation "'+operation+'"');}break;case'undefined':ret='';break;default:throw new Error('Unexpected type in AST: '+typeof node);}return ret;};};mw.jqueryMsg.htmlEmitter.prototype={concat:function(nodes){var $span=$('<span>').addClass(
'mediaWiki_htmlEmitter');$.each(nodes,function(i,node){if(node instanceof jQuery&&node.hasClass('mediaWiki_htmlEmitter')){$.each(node.contents(),function(j,childNode){appendWithoutParsing($span,childNode);});}else{appendWithoutParsing($span,node);}});return $span;},replace:function(nodes,replacements){var index=parseInt(nodes[0],10);if(index<replacements.length){return replacements[index];}else{return'$'+(index+1);}},wikilink:function(nodes){var page,anchor,url;page=nodes[0];url=mw.util.getUrl(page);if(nodes.length===1){anchor=page;}else{anchor=nodes[1];}return $('<a>').attr({title:page,href:url}).text(anchor);},htmlattributes:function(nodes){var i,len,mapping={};for(i=0,len=nodes.length;i<len;i+=2){mapping[nodes[i]]=decodePrimaryHtmlEntities(nodes[i+1]);}return mapping;},htmlelement:function(nodes){var tagName,attributes,contents,$element;tagName=nodes.shift();attributes=nodes.shift();contents=nodes;$element=$(document.createElement(tagName)).attr(attributes);return appendWithoutParsing
($element,contents);},extlink:function(nodes){var $el,arg=nodes[0],contents=nodes[1];if(arg instanceof jQuery){$el=arg;}else{$el=$('<a>');if(typeof arg==='function'){$el.click(arg).attr('href','#');}else{$el.attr('href',arg.toString());}}return appendWithoutParsing($el,contents);},extlinkparam:function(nodes,replacements){var replacement,index=parseInt(nodes[0],10);if(index<replacements.length){replacement=replacements[index];}else{replacement='$'+(index+1);}return this.extlink([replacement,nodes[1]]);},plural:function(nodes){var forms,count;count=parseFloat(this.language.convertNumber(nodes[0],true));forms=nodes.slice(1);return forms.length?this.language.convertPlural(count,forms):'';},gender:function(nodes){var gender,maybeUser=nodes[0],forms=nodes.slice(1);if(maybeUser===''){maybeUser=mw.user;}if(maybeUser&&maybeUser.options instanceof mw.Map){gender=maybeUser.options.get('gender');}else{gender=maybeUser;}return this.language.gender(gender,forms);},grammar:function(nodes){var form=
nodes[0],word=nodes[1];return word&&form&&this.language.convertGrammar(word,form);},'int':function(nodes){return mw.jqueryMsg.getMessageFunction()(nodes[0].toLowerCase());},formatnum:function(nodes){var isInteger=(nodes[1]&&nodes[1]==='R')?true:false,number=nodes[0];return this.language.convertNumber(number,isInteger);}};mw.log.deprecate(window,'gM',mw.jqueryMsg.getMessageFunction(),'Use mw.message( ... ).parse() instead.');$.fn.msg=mw.jqueryMsg.getPlugin();oldParser=mw.Message.prototype.parser;mw.Message.prototype.parser=function(){var messageFunction;if(this.format==='plain'||!/\{\{|[\[<>]/.test(this.map.get(this.key))){return oldParser.apply(this);}messageFunction=mw.jqueryMsg.getMessageFunction({'messages':this.map,'format':this.format});return messageFunction(this.key,this.parameters);};}(mediaWiki,jQuery));},{},{});mw.loader.implement("mediawiki.legacy.ajax",function(){(function(mw){function debug(text){if(!window.sajax_debug_mode){return false;}var e=document.getElementById(
'sajax_debug');if(!e){e=document.createElement('p');e.className='sajax_debug';e.id='sajax_debug';var b=document.getElementsByTagName('body')[0];if(b.firstChild){b.insertBefore(e,b.firstChild);}else{b.appendChild(e);}}var m=document.createElement('div');m.appendChild(document.createTextNode(text));e.appendChild(m);return true;}function createXhr(){debug('sajax_init_object() called..');var a;try{a=new XMLHttpRequest();}catch(xhrE){try{a=new window.ActiveXObject('Msxml2.XMLHTTP');}catch(msXmlE){try{a=new window.ActiveXObject('Microsoft.XMLHTTP');}catch(msXhrE){a=null;}}}if(!a){debug('Could not create connection object.');}return a;}function doAjaxRequest(func_name,args,target){var i,x,uri,post_data;uri=mw.util.wikiScript()+'?action=ajax';if(window.sajax_request_type==='GET'){if(uri.indexOf('?')===-1){uri=uri+'?rs='+encodeURIComponent(func_name);}else{uri=uri+'&rs='+encodeURIComponent(func_name);}for(i=0;i<args.length;i++){uri=uri+'&rsargs[]='+encodeURIComponent(args[i]);}post_data=null;}
else{post_data='rs='+encodeURIComponent(func_name);for(i=0;i<args.length;i++){post_data=post_data+'&rsargs[]='+encodeURIComponent(args[i]);}}x=createXhr();if(!x){alert('AJAX not supported');return false;}try{x.open(window.sajax_request_type,uri,true);}catch(e){if(location.hostname==='localhost'){alert('Your browser blocks XMLHttpRequest to "localhost", try using a real hostname for development/testing.');}throw e;}if(window.sajax_request_type==='POST'){x.setRequestHeader('Method','POST '+uri+' HTTP/1.1');x.setRequestHeader('Content-Type','application/x-www-form-urlencoded');}x.setRequestHeader('Pragma','cache=yes');x.setRequestHeader('Cache-Control','no-transform');x.onreadystatechange=function(){if(x.readyState!==4){return;}debug('received ('+x.status+' '+x.statusText+') '+x.responseText);if(typeof target==='function'){target(x);}else if(typeof target==='object'){if(target.tagName==='INPUT'){if(x.status===200){target.value=x.responseText;}}else{if(x.status===200){target.innerHTML=x.
responseText;}else{target.innerHTML='<div class="error">Error: '+x.status+' '+x.statusText+' ('+x.responseText+')</div>';}}}else{alert('Bad target for sajax_do_call: not a function or object: '+target);}};debug(func_name+' uri = '+uri+' / post = '+post_data);x.send(post_data);debug(func_name+' waiting..');return true;}function wfSupportsAjax(){var request=createXhr(),supportsAjax=request?true:false;request=undefined;return supportsAjax;}var deprecationNotice='Sajax is deprecated, use jQuery.ajax or mediawiki.api instead.';mw.log.deprecate(window,'sajax_debug_mode',false,deprecationNotice);mw.log.deprecate(window,'sajax_request_type','GET',deprecationNotice);mw.log.deprecate(window,'sajax_debug',debug,deprecationNotice);mw.log.deprecate(window,'sajax_init_object',createXhr,deprecationNotice);mw.log.deprecate(window,'sajax_do_call',doAjaxRequest,deprecationNotice);mw.log.deprecate(window,'wfSupportsAjax',wfSupportsAjax,deprecationNotice);}(mediaWiki));},{},{});mw.loader.implement(
"mediawiki.libs.pluralruleparser",function(){(function(mw){function pluralRuleParser(rule,number){rule=rule.split('@')[0].replace(/^\s*/,'').replace(/\s*$/,'');if(!rule.length){return true;}var pos=0,operand,expression,relation,result,whitespace=makeRegexParser(/^\s+/),value=makeRegexParser(/^\d+/),_n_=makeStringParser('n'),_i_=makeStringParser('i'),_f_=makeStringParser('f'),_t_=makeStringParser('t'),_v_=makeStringParser('v'),_w_=makeStringParser('w'),_is_=makeStringParser('is'),_isnot_=makeStringParser('is not'),_isnot_sign_=makeStringParser('!='),_equal_=makeStringParser('='),_mod_=makeStringParser('mod'),_percent_=makeStringParser('%'),_not_=makeStringParser('not'),_in_=makeStringParser('in'),_within_=makeStringParser('within'),_range_=makeStringParser('..'),_comma_=makeStringParser(','),_or_=makeStringParser('or'),_and_=makeStringParser('and');function debug(){}debug('pluralRuleParser',rule,number);function choice(parserSyntax){return function(){for(var i=0;i<parserSyntax.length;i++
){var result=parserSyntax[i]();if(result!==null){return result;}}return null;};}function sequence(parserSyntax){var originalPos=pos;var result=[];for(var i=0;i<parserSyntax.length;i++){var res=parserSyntax[i]();if(res===null){pos=originalPos;return null;}result.push(res);}return result;}function nOrMore(n,p){return function(){var originalPos=pos;var result=[];var parsed=p();while(parsed!==null){result.push(parsed);parsed=p();}if(result.length<n){pos=originalPos;return null;}return result;};}function makeStringParser(s){var len=s.length;return function(){var result=null;if(rule.substr(pos,len)===s){result=s;pos+=len;}return result;};}function makeRegexParser(regex){return function(){var matches=rule.substr(pos).match(regex);if(matches===null){return null;}pos+=matches[0].length;return matches[0];};}function i(){var result=_i_();if(result===null){debug(' -- failed i',parseInt(number,10));return result;}result=parseInt(number,10);debug(' -- passed i ',result);return result;}function n(){
var result=_n_();if(result===null){debug(' -- failed n ',number);return result;}result=parseFloat(number,10);debug(' -- passed n ',result);return result;}function f(){var result=_f_();if(result===null){debug(' -- failed f ',number);return result;}result=(number+'.').split('.')[1]||0;debug(' -- passed f ',result);return result;}function t(){var result=_t_();if(result===null){debug(' -- failed t ',number);return result;}result=(number+'.').split('.')[1].replace(/0$/,'')||0;debug(' -- passed t ',result);return result;}function v(){var result=_v_();if(result===null){debug(' -- failed v ',number);return result;}result=(number+'.').split('.')[1].length||0;debug(' -- passed v ',result);return result;}function w(){var result=_w_();if(result===null){debug(' -- failed w ',number);return result;}result=(number+'.').split('.')[1].replace(/0$/,'').length||0;debug(' -- passed w ',result);return result;}operand=choice([n,i,f,t,v,w]);expression=choice([mod,operand]);function mod(){var result=sequence(
[operand,whitespace,choice([_mod_,_percent_]),whitespace,value]);if(result===null){debug(' -- failed mod');return null;}debug(' -- passed '+parseInt(result[0],10)+' '+result[2]+' '+parseInt(result[4],10));return parseInt(result[0],10)%parseInt(result[4],10);}function not(){var result=sequence([whitespace,_not_]);if(result===null){debug(' -- failed not');return null;}return result[1];}function is(){var result=sequence([expression,whitespace,choice([_is_]),whitespace,value]);if(result!==null){debug(' -- passed is : '+result[0]+' == '+parseInt(result[4],10));return result[0]===parseInt(result[4],10);}debug(' -- failed is');return null;}function isnot(){var result=sequence([expression,whitespace,choice([_isnot_,_isnot_sign_]),whitespace,value]);if(result!==null){debug(' -- passed isnot: '+result[0]+' != '+parseInt(result[4],10));return result[0]!==parseInt(result[4],10);}debug(' -- failed isnot');return null;}function not_in(){var result=sequence([expression,whitespace,_isnot_sign_,
whitespace,rangeList]);if(result!==null){debug(' -- passed not_in: '+result[0]+' != '+result[4]);var range_list=result[4];for(var i=0;i<range_list.length;i++){if(parseInt(range_list[i],10)===parseInt(result[0],10)){return false;}}return true;}debug(' -- failed not_in');return null;}function rangeList(){var result=sequence([choice([range,value]),nOrMore(0,rangeTail)]);var resultList=[];if(result!==null){resultList=resultList.concat(result[0]);if(result[1][0]){resultList=resultList.concat(result[1][0]);}return resultList;}debug(' -- failed rangeList');return null;}function rangeTail(){var result=sequence([_comma_,rangeList]);if(result!==null){return result[1];}debug(' -- failed rangeTail');return null;}function range(){var i;var result=sequence([value,_range_,value]);if(result!==null){debug(' -- passed range');var array=[];var left=parseInt(result[0],10);var right=parseInt(result[2],10);for(i=left;i<=right;i++){array.push(i);}return array;}debug(' -- failed range');return null;}function
_in(){var result=sequence([expression,nOrMore(0,not),whitespace,choice([_in_,_equal_]),whitespace,rangeList]);if(result!==null){debug(' -- passed _in:'+result);var range_list=result[5];for(var i=0;i<range_list.length;i++){if(parseInt(range_list[i],10)===parseInt(result[0],10)){return(result[1][0]!=='not');}}return(result[1][0]==='not');}debug(' -- failed _in ');return null;}function within(){var result=sequence([expression,nOrMore(0,not),whitespace,_within_,whitespace,rangeList]);if(result!==null){debug(' -- passed within');var range_list=result[5];if((result[0]>=parseInt(range_list[0],10))&&(result[0]<parseInt(range_list[range_list.length-1],10))){return(result[1][0]!=='not');}return(result[1][0]==='not');}debug(' -- failed within ');return null;}relation=choice([is,not_in,isnot,_in,within]);function and(){var result=sequence([relation,nOrMore(0,andTail)]);if(result){if(!result[0]){return false;}for(var i=0;i<result[1].length;i++){if(!result[1][i]){return false;}}return true;}debug(
' -- failed and');return null;}function andTail(){var result=sequence([whitespace,_and_,whitespace,relation]);if(result!==null){debug(' -- passed andTail'+result);return result[3];}debug(' -- failed andTail');return null;}function orTail(){var result=sequence([whitespace,_or_,whitespace,and]);if(result!==null){debug(' -- passed orTail: '+result[3]);return result[3];}debug(' -- failed orTail');return null;}function condition(){var result=sequence([and,nOrMore(0,orTail)]);if(result){for(var i=0;i<result[1].length;i++){if(result[1][i]){return true;}}return result[0];}return false;}result=condition();if(result===null){throw new Error('Parse error at position '+pos.toString()+' for rule: '+rule);}if(pos!==rule.length){debug('Warning: Rule not parsed completely. Parser stopped at '+rule.substr(0,pos)+' for rule: '+rule);}return result;}mw.libs.pluralRuleParser=pluralRuleParser;})(mediaWiki);},{},{});mw.loader.implement("skins.vector.compactPersonalBar.defaultTracking",function(){(function(mw
,$){'use strict';function trackClick(el,name){mw.beta.trackClick(el,'PersonalBar',{action:'link-click',link:name,version:'default',userId:mw.user.getId()});}$(function(){trackClick('#pt-userpage','user-page');trackClick('#pt-mycontris','contributions');trackClick('#pt-notifications','notifications');trackClick('#pt-mytalk','talk');trackClick('#pt-watchlist','watchlist');trackClick('#pt-preferences','preferences');trackClick('#pt-betafeatures','beta');trackClick('#pt-logout','logout');trackClick('#pt-uls','language');trackClick('#footer-places-privacy','privacy');trackClick('#n-help','help');});}(mediaWiki,jQuery));},{},{});
/* cache key: enwiki:resourceloader:filter:minify-js:7:36e59157ed00320bc65a0e9532392a86 */